package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type CreateFirewallRuleLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewCreateFirewallRuleLogic(ctx context.Context, svcCtx *svc.ServiceContext) *CreateFirewallRuleLogic {
	return &CreateFirewallRuleLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *CreateFirewallRuleLogic) CreateFirewallRule(req *types.CreateFirewallRuleReq) (resp *types.CreateFirewallRuleResp, err error) {
	// todo: add your logic here and delete this line
	CreateFirewallRuleReq := &openstack.CreateFirewallRuleReq{}
	err = copier.CopyWithOption(CreateFirewallRuleReq, req, copier.Option{Converters: utils.Converters})
	CreateFirewallRuleResp, err := l.svcCtx.OpenstackRpc.CreateFirewallRule(l.ctx, CreateFirewallRuleReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&CreateFirewallRuleResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &CreateFirewallRuleResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
